1 # This file is sourced by init.sh, *before* its initialization.
3 # Copyright (C) 2010-2012 Free Software Foundation, Inc.
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
19 # This goes hand in hand with the "exec 9>&2;" in tests/Makefile.am's
20 # TESTS_ENVIRONMENT definition.
23 # Having an unsearchable directory in PATH causes execve to fail with EACCES
24 # when applied to an unresolvable program name, contrary to the desired ENOENT.
25 # Avoid the problem by rewriting PATH to exclude unsearchable directories.
26 # Also, if PATH lacks /sbin and/or /usr/sbin, append it/them.
29 # FIXME: remove double quotes around $IFS when all tests use init.sh.
30 # They constitute a work-around for a bug in FreeBSD 8.1's /bin/sh.
31 local saved_IFS="$IFS"
40 test -z "$d" && d1=. || d1=$d
41 if ls -d "$d1/." > /dev/null 2>&1; then
42 new_path="$new_path$colon$d"
47 for d in /sbin /usr/sbin ; do
50 *) new_path="$new_path:$d" ;;
61 test "$INT_MAX" || fatal_ "running getlimits"
66 getfacl --version < /dev/null > /dev/null 2>&1 \
67 && setfacl --version < /dev/null > /dev/null 2>&1 \
68 || skip_ "This test requires getfacl and setfacl."
70 id -u bin > /dev/null 2>&1 \
71 || skip_ "This test requires a local user named bin."
76 test $# = 1 || framework_failure_
77 df --local "$1" >/dev/null 2>&1
83 skip_ "This test must be run on a local file system."
86 # Skip this test if we're not in SELinux "enforcing" mode.
87 require_selinux_enforcing_()
89 test "$(getenforce)" = Enforcing \
90 || skip_ "This test is useful only with SELinux in Enforcing mode."
93 require_openat_support_()
95 # Skip this test if your system has neither the openat-style functions
96 # nor /proc/self/fd support with which to emulate them.
97 test -z "$CONFIG_HEADER" \
98 && skip_ 'internal error: CONFIG_HEADER not defined'
101 grep '^#define HAVE_OPENAT' "$CONFIG_HEADER" > /dev/null && _skip=no
102 test -d /proc/self/fd && _skip=no
103 if test $_skip = yes; then
104 skip_ 'this system lacks openat support'
111 # Expect to be able to exec a program in 10MB of virtual memory,
112 # but not in 20KB. I chose "date". It must not be a shell built-in
113 # function, so you can't use echo, printf, true, etc.
114 # Of course, in coreutils, I could use $top_builddir/src/true,
115 # but this should be able to work for other projects, too.
116 ( ulimit -v 10000; date ) > /dev/null 2>&1 || ulimit_works=no
117 ( ulimit -v 20; date ) > /dev/null 2>&1 && ulimit_works=no
119 test $ulimit_works = no \
120 && skip_ "this shell lacks ulimit support"
123 require_readable_root_()
125 test -r / || skip_ "/ is not readable"
128 # Skip the current test if strace is not available or doesn't work
129 # with the named syscall. Usage: require_strace_ unlink
132 test $# = 1 || framework_failure_
134 strace -V < /dev/null > /dev/null 2>&1 ||
135 skip_ 'no strace program'
137 strace -qe "$1" echo > /dev/null 2>&1 ||
138 skip_ 'strace -qe "'"$1"'" does not work'
140 # On some linux/sparc64 systems, strace works fine on 32-bit executables,
141 # but prints only one line of output for every 64-bit executable.
142 strace -o log-help ls --help >/dev/null || framework_failure_
143 n_lines_help=$(wc -l < log-help)
145 if test $n_lines_help = 0 || test $n_lines_help = 1; then
146 skip_ 'strace produces no more than one line of output'
152 setfacl -m user::rwx . \
153 || skip_ "setfacl does not work on the current file system"
156 # Require a controlling input 'terminal'.
157 require_controlling_input_terminal_()
159 tty -s || have_input_tty=no
160 test -t 0 || have_input_tty=no
161 if test "$have_input_tty" = no; then
162 skip_ 'requires controlling input terminal
163 This test must have a controlling input "terminal", so it may not be
164 run via "batch", "at", or "ssh". On some systems, it may not even be
165 run in the background.'
173 case " $built_programs " in
175 *) echo "$i: not built" 1>&2; skip_=yes ;;
179 test $skip_ = yes && skip_ "required program(s) not built"
182 require_file_system_bytes_free_()
185 local expr=$(stat -f --printf "$req / %S <= %a" .)
186 awk "BEGIN{ exit !($expr) }" \
187 || skip_ "this test needs at least $req bytes of free space"
192 # Make sure id -u succeeds.
194 || { echo "$0: cannot run 'id -u'" 1>&2; return 1; }
196 # Make sure it gives valid output.
200 echo "$0: invalid output ('$my_uid') from 'id -u'" 1>&2
206 get_process_status_()
208 sed -n '/^State:[ ]*\([[:alpha:]]\).*/s//\1/p' /proc/$1/status
211 # Convert an ls-style permission string, like drwxr----x and -rw-r-x-wx
212 # to the equivalent chmod --mode (-m) argument, (=,u=rwx,g=r,o=x and
213 # =,u=rw,g=rx,o=wx). Ignore ACLs.
218 *) echo "$0: wrong number of arguments" 1>&2
219 echo "Usage: $0 ls-style-mode-string" 1>&2
224 [ld-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxtT-]) ;;
225 [ld-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxtT-][+.]) ;;
226 *) echo "$0: invalid mode string: $rwx" 1>&2; return;;
229 # Perform these conversions:
234 # The 'T' and 't' ones are only valid for 'other'.
235 s='s/S/@/;s/s/x@/;s/@/s/'
236 t='s/T/@/;s/t/x@/;s/@/t/'
238 u=`echo $rwx|sed 's/^.\(...\).*/,u=\1/;s/-//g;s/^,u=$//;'$s`
239 g=`echo $rwx|sed 's/^....\(...\).*/,g=\1/;s/-//g;s/^,g=$//;'$s`
240 o=`echo $rwx|sed 's/^.......\(...\).*/,o=\1/;s/-//g;s/^,o=$//;'$s';'$t`
247 root) skip_ must be run as root ;;
248 non-root) skip_ must be run as non-root ;;
255 # When in a chroot of an SELinux-enabled system, but with a mock-simulated
256 # SELinux-*disabled* system, recognize that SELinux is disabled system wide:
257 grep 'selinuxfs$' /proc/filesystems > /dev/null \
258 || skip_ "this system lacks SELinux support"
260 # Independent of whether SELinux is enabled system-wide,
261 # the current file system may lack SELinux support.
264 skip_ "this system (or maybe just" \
265 "the current file system) lacks SELinux support"
272 if test "$RUN_VERY_EXPENSIVE_TESTS" != yes; then
273 skip_ 'very expensive: disabled by default
274 This test is very expensive, so it is disabled by default.
275 To run it anyway, rerun make check with the RUN_VERY_EXPENSIVE_TESTS
276 environment variable set to yes. E.g.,
278 env RUN_VERY_EXPENSIVE_TESTS=yes make check
280 or use the shortcut target of the toplevel Makefile,
282 make check-very-expensive
289 if test "$RUN_EXPENSIVE_TESTS" != yes; then
290 skip_ 'expensive: disabled by default
291 This test is relatively expensive, so it is disabled by default.
292 To run it anyway, rerun make check with the RUN_EXPENSIVE_TESTS
293 environment variable set to yes. E.g.,
295 env RUN_EXPENSIVE_TESTS=yes make check
297 or use the shortcut target of the toplevel Makefile,
306 uid_is_privileged_ || skip_ "must be run as root"
307 NON_ROOT_USERNAME=${NON_ROOT_USERNAME=nobody}
308 NON_ROOT_GROUP=${NON_ROOT_GROUP=$(id -g $NON_ROOT_USERNAME)}
311 skip_if_root_() { uid_is_privileged_ && skip_ "must be run as non-root"; }
313 # Set 'groups' to a space-separated list of at least two groups
314 # of which the user is a member.
315 require_membership_in_two_groups_()
317 test $# = 0 || framework_failure_
319 groups=${COREUTILS_GROUPS-`(id -G || /usr/xpg4/bin/id -G) 2>/dev/null`}
322 *) skip_ 'requires membership in two groups
323 this test requires that you be a member of more than one group,
324 but running 'id -G'\'' either failed or found just one. If you really
325 are a member of at least two groups, then rerun this test with
326 COREUTILS_GROUPS set in your environment to the space-separated list
327 of group names or numbers. E.g.,
329 env COREUTILS_GROUPS='\''users cdrom'\'' make check
336 # Is /proc/$PID/status supported?
337 require_proc_pid_status_()
342 grep '^State:[ ]*[S]' /proc/$pid/status > /dev/null 2>&1 ||
343 skip_ "/proc/$pid/status: missing or 'different'"
347 # Return nonzero if the specified path is on a file system for
348 # which FIEMAP support exists. Note some file systems (like ext3 and btrfs)
349 # only support FIEMAP for files, not directories.
352 if ! python < /dev/null; then
353 warn_ 'fiemap_capable_: python missing: assuming not fiemap capable'
356 python $abs_srcdir/fiemap-capable "$@"
359 # Skip the current test if "." lacks d_type support.
360 require_dirent_d_type_()
363 || skip_ python missing: assuming no d_type support
365 python $abs_srcdir/d_type-check \
366 || skip_ requires d_type support
369 # Skip the current test if we lack Perl.
373 $PERL -e 'use warnings' > /dev/null 2>&1 \
374 || skip_ 'configure did not find a usable version of Perl'
377 # Does the current (working-dir) file system support sparse files?
378 require_sparse_support_()
380 test $# = 0 || framework_failure_
381 # Test whether we can create a sparse file.
382 # For example, on Darwin6.5 with a file system of type hfs, it's not possible.
383 # NTFS requires 128K before a hole appears in a sparse file.
385 dd bs=1 seek=128K of=$t < /dev/null 2> /dev/null
389 if test $kb_size -ge 128; then
390 skip_ 'this file system does not support sparse files'
396 test $# = 1 || framework_failure_
397 if ! mkfifo "$1"; then
398 # Make an exception of this case -- usually we interpret framework-creation
399 # failure as a test failure. However, in this case, when running on a SunOS
400 # system using a disk NFS mounted from OpenBSD, the above fails like this:
401 # mkfifo: cannot make fifo 'fifo-10558': Not owner
402 skip_ 'unable to create a fifo'
406 # Disable the current test if the working directory seems to have
407 # the setgid bit set.
410 setgid_tmpdir=setgid-$$
411 (umask 77; mkdir $setgid_tmpdir)
412 perms=$(stat --printf %A $setgid_tmpdir)
416 drwxr-xr-x);; # Windows98 + DJGPP 2.03
417 *) skip_ 'this directory has the setgid bit set';;
421 skip_if_mcstransd_is_running_()
423 test $# = 0 || framework_failure_
425 # When mcstransd is running, you'll see only the 3-component
426 # version of file-system context strings. Detect that,
427 # and if it's running, skip this test.
428 __ctx=$(stat --printf='%C\n' .) || framework_failure_
430 *:*:*:*) ;; # four components is ok
431 *) # anything else probably means mcstransd is running
432 skip_ "unexpected context '$__ctx'; turn off mcstransd" ;;
436 # Skip the current test if umask doesn't work as usual.
437 # This test should be run in the temporary directory that ends
438 # up being removed via the trap commands.
439 working_umask_or_skip_()
444 perms=`ls -l file1 file2 | sed 's/ .*//' | uniq`
449 '*) skip_ 'your build directory has unusual umask semantics'
453 # Retry a function requiring a sufficient delay to _pass_
454 # using a truncated exponential backoff method.
455 # Example: retry_delay_ dd_reblock_1 .1 6
456 # This example will call the dd_reblock_1 function with
457 # an initial delay of .1 second and call it at most 6 times
458 # with a max delay of 3.2s (doubled each time), or a total of 6.3s
459 # Note ensure you do _not_ quote the parameter to GNU sleep in
460 # your function, as it may contain separate values that `sleep`
461 # needs to accumulate.
469 local num_sleeps=$attempt
471 while test $attempt -le $max_n_tries; do
472 local delay=$($AWK -v n=$num_sleeps -v s="$init_delay" \
473 'BEGIN { print s * n }')
474 "$test_func" "$delay" && { time_fail=0; break; } || time_fail=1
475 attempt=$(expr $attempt + 1)
476 num_sleeps=$(expr $num_sleeps '*' 2)
478 test "$time_fail" = 0
481 # Call this with a list of programs under test immediately after
485 if test "$VERBOSE" = yes; then
493 # Are we running on GNU/Hurd?
496 test "$(uname)" = GNU \
497 || skip_ 'not running on GNU/Hurd'